package cokr.xit.fims.levy.service;

import java.util.List;

import cokr.xit.fims.levy.Levy;
import cokr.xit.fims.levy.LevyQuery;
import cokr.xit.foundation.data.DataObject;

/**부과 대장 관리 서비스 인터페이스.
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-30	JoJH 최초 작성
 * ================================
 * </pre>
 */
public interface LevyService {

	/**지정한 조건에 따라 감경부과 대상 목록을 조회하여 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 목록
	 */
	List<DataObject> getRdctLevyTrgtList(LevyQuery req);

	/**지정한 조건에 따라 부과 대장 목록을 조회하여 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 목록
	 */
	List<DataObject> getLevyList(LevyQuery req);

	/**지정한 조건에 따라 부과 대장 객체들을 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체 목록
	 */
	List<Levy> getLevys(LevyQuery req);

	/**지정한 부과 ID의 부과 대장 객체를 반환한다.<br />
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체
	 */
	DataObject getLevyInfo(LevyQuery req);

	/**지정한 회계연도, 회계구분코드, 세목코드의 새로운 부과번호를 반환한다.<br />
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체
	 */
	String getMaxLevyNo(LevyQuery req);

	/**사전 부과 대장 정보를 등록한다.
	 * @param req 부과 대장 조회 조건
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createRdctLevy(Levy levy);

	String createRdctLevyList(LevyQuery req);

}
